/* Copyright (c) 2009, Sean A.O. Harney */

//~--- JDK imports ------------------------------------------------------------
import java.awt.*;

import javax.swing.*;
import javax.swing.text.*;

public class ConsolePanel extends JPanel {
	private int printCount = -1;
	private JScrollPane scrollPane;
	private JTextPane textPane;

	public ConsolePanel(Dimension dim) {

		setBackground(Color.GRAY);
		textPane = new JTextPane();

		textPane.setEditable(false);
		scrollPane = new JScrollPane(textPane,
				ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		scrollPane.setPreferredSize(dim);
		add(scrollPane);
	}

	// method for outputing messages to console panel
	public void println(Color c, String s) {
		System.out.println("+" + s);
		StyleContext sc = StyleContext.getDefaultStyleContext();
		AttributeSet aset = sc.addAttribute(SimpleAttributeSet.EMPTY,
				StyleConstants.Foreground, c);
		int len = this.textPane.getDocument().getLength();

		textPane.setEditable(true);
		// System.out.println("len = " + len);
		textPane.setCaretPosition(len); // place caret at the end (with no
		// selection)
		textPane.setCharacterAttributes(aset, false);
		textPane.replaceSelection(++printCount + ": " + s + "\n"); // there is
		// no
		// selection,
		// so
		// inserts
		// at caret
		// scroll the text as it gets more and more
		textPane.setCaretPosition(textPane.getText().length());
		// textPane.setEditable(false);
	}

	public void println(String s) {
		println(Color.BLUE, s);
	}
}
