/* Copyright (c) 2009, Sean A.O. Harney */

//~--- JDK imports ------------------------------------------------------------
import java.awt.*;

import javax.swing.*;
import javax.swing.text.*;

public class ConsolePanels extends JPanel {

	JTabbedPane tabPane = null;
	ConsolePanel consoleAll,consoleDps,consoleKmemstat,consoleKsymstat,consoleKtraq,consoleDrchk,consoleJkmt;

	public ConsolePanels(Dimension dim) {

		tabPane = new JTabbedPane();

		consoleAll = new ConsolePanel(dim);
		tabPane.add("All", consoleAll);
		consoleDps = new ConsolePanel(dim);
		tabPane.add("dps", consoleDps);
		consoleKmemstat = new ConsolePanel(dim);
		tabPane.add("kmemstat", consoleKmemstat);
		consoleKsymstat = new ConsolePanel(dim);
		tabPane.add("ksymstat", consoleKsymstat);
		consoleKtraq = new ConsolePanel(dim);
		tabPane.add("ktraq", consoleKtraq);
		consoleDrchk = new ConsolePanel(dim);
		tabPane.add("dr_chk", consoleDrchk);
		consoleJkmt = new ConsolePanel(dim);
		tabPane.add("Jkmt", consoleJkmt);


		add(tabPane);
	}
	public void printlnAll(String s) {
		consoleAll.println(s);
	}
	public void printlnAll(Color c, String s) {
		consoleAll.println(c, s);
	}
	public void printlnDps(String s) {
		consoleDps.println(s);
		printlnAll(s);
	}
	public void printlnDps(Color c, String s) {
		consoleDps.println(c, s);
		printlnAll(c, s);
	}
	public void printlnKmemstat(String s) {
		consoleKmemstat.println(s);
		printlnAll(s);
	}
	public void printlnKmemstat(Color c, String s) {
		consoleKmemstat.println(c, s);
		printlnAll(c, s);
	}
	public void printlnKsymstat(String s) {
		consoleKsymstat.println(s);
		printlnAll(s);
	}
	public void printlnKsymstat(Color c, String s) {
		consoleKsymstat.println(c, s);
		printlnAll(c, s);
	}
	public void printlnKtraq(String s) {
		consoleKtraq.println(s);
		printlnAll(s);
	}
	public void printlnKtraq(Color c, String s) {
		consoleKtraq.println(c, s);
		printlnAll(c, s);
	}
	public void printlnDrchk(String s) {
		consoleDrchk.println(s);
		printlnAll(s);
	}
	public void printlnDrchk(Color c, String s) {
		consoleDrchk.println(c, s);
		printlnAll(c, s);
	}
	public void printlnJkmt(String s) {
		consoleJkmt.println(s);
		printlnAll(s);
	}
	public void printlnJkmt(Color c, String s) {
		consoleJkmt.println(c, s);
		printlnAll(c, s);
	}


	public void println(String toolName, Color c, String s) {
	    if("dps".equals(toolName))
		printlnDps(c, s);
	   else if("kmemstat".equals(toolName))
		printlnKmemstat(c, s);
	   else if("ksymstat".equals(toolName))
		printlnKsymstat(c, s);
	   else if("ktraq".equals(toolName))
		printlnKtraq(c, s);
	else if("dr_chk".equals(toolName))
		printlnDrchk(c, s);

	}








}
