#include <stdio.h>
#include <string.h>
#include <sys/utsname.h>
#include <unistd.h>
#include <stdlib.h>

/* 
 * Use like so:
 * char sysmap_path[255];
 * int sysmap_path_len;
 * sysmap_path_len = get_sysmap_path(sysmap_path);
 * if (sysmap_path_len > 0)
 * 	printf("System.map path is: %s\n", sysmap_path);
 *
 */

int get_sysmap_path(char *path)
{
	
	struct utsname uts;
	char *sysmap_release;
	char *sysmap_modules;
	char *sysmap_bootdir;
	char *sysmap_srcdir;
	char *sysmap_inroot;
	int ret;
	FILE *fd;

	if (uname(&uts) < 0)
		return -1;
		
	if ((sysmap_release = (char *)malloc(255)) == NULL)
		return -1;
	if ((sysmap_modules = (char *)malloc(255)) == NULL)
                return -1;
	
	snprintf(sysmap_release, sizeof(sysmap_release), "/boot/System.map-%s", uts.release);
	snprintf(sysmap_modules, sizeof(sysmap_modules), "/lib/modules/%s/System.map", uts.release);
	
	if ((fd = fopen(sysmap_release, "r")) != NULL)
	{
		fclose(fd);
		strcpy(path, sysmap_release);
		ret = strlen(sysmap_release);	
		free(sysmap_release);
		return ret;
	}
	else
	if ((fd = fopen(sysmap_modules, "r")) != NULL)
        {
		fclose(fd);
                strcpy(path, sysmap_modules);
                ret = strlen(sysmap_modules);
		free(sysmap_release);
		return ret;
        }
	else
	if ((fd = fopen("/boot/System.map", "r")) != NULL)
	{			
		fclose(fd);
		strcpy(path, "/boot/System.map");
		ret = 16;
		return ret;
	}
	else
	if ((fd = fopen("/usr/src/linux/System.map", "r")) != NULL)
	{
		fclose(fd);
		strcpy(path, "/usr/src/linux/System.map");
		ret = strlen("/usr/src/linux/System.map");
		return ret;
	}	
	else
	if ((fd = fopen("/System.map", "r")) != NULL)
	{
                fclose(fd);
                strcpy(path, "/System.map");
                ret = strlen("/System.map");
                return ret;
        }
	fclose(fd);
	return -1;
}
