#include "kmtd.h"

char *panic_message[] = {
//SYSMAP_PANIC 0
"System.map modification since last scan",
//KERNIMG_PANIC 1
"Kernel image (i.e vmlinux) modification since last scan",
//MISC_PANIC 2
"Misc. failure (i.e memory allocation)",
NULL
};
extern uint8_t sysmap_digest[16];
extern uint8_t kernelf_digest[16];
extern char sysmap_path[255], kernimg_path[255];

void kmtd_panic(int flag)
{
        FILE *fd;
        char time_buf[255];
        time_t clock;
        struct tm *tm;

        if ((fd = fopen("/var/log/kmt/kmtd.log", "a+")) == NULL)
                exit(-1);

        time (&clock);
        tm = gmtime (&clock);
        setlocale (LC_TIME, "C");
        strftime (time_buf, sizeof (time_buf), "%A, %B %e, %Y, %H:%M:%S", tm);

        fprintf(fd, "%s [kmtd_panic] kmtd shutdown due to %s\n", time_buf, panic_message[flag]);
        fflush(fd);
	
	if (flag == SYSMAP_PANIC || flag == KERNIMG_PANIC)
	{
		NotifyUsers("ALERT! This is an important message from KMTD (Your KMT Daemon).\n"
		    "I have discovered that there has been a [%s]. As a result I am shutting\n"
		    "myself down. If this message is a result of a System.map or Kernel image\n"
		    "modification, then you may have a hacker present, who is attempting to modify\n"
		    "either one of those files, so that they match a kernel rootkits memory\n"
		    "modifications. Fortunately I am not foolish enough to compare a modified signature\n"
		    "against kernel memory. Please confirm that you are using valid System.map, and\n"
		    "kernel image.\n"
		    , panic_message[flag]);
		    
		    
	}
	else
		 NotifyUsers("ALERT! This is an important message from KMTD (Your KMT Daemon).\n"
			     "I am shutting myself down due to an internal System error: \n[%s]\n", panic_message[flag]);
	/* Exit out */
	exit(0);

}

