/*       
 *      Ktraq - v0.2 This module is a part of the Ktraq IDS 
 *
 * 	This LKM makes a list of all of the system call addresses as they appear in memory
 * 	It writes them to a file, which is then read by our user space code, which assigns
 * 	then a name, and checks their authenticity by querying against their addresses as
 * 	they were assigned when the kernel was compiled.
 *
 *      (C) 2008 Ryan O'Neill <ryan@bitlackeys.com> 
 */    



#include "ktraq.h" 

#define MAX_SYSCALL 256
#define SCA "/tmp/sca.tmp"
MODULE_LICENSE ("(C)");


unsigned long sct;
module_param (sct, ulong, 0644);

int sct_query(void)
{
           
	   int i = 0;
           struct file *file; 
           char *buf;
        
            unsigned long **sys_call_table = (unsigned long **)sct; 

            printk("sct: %x\n", sct);
 	    buf = kmalloc(64, GFP_KERNEL);

            mm_segment_t o_fs = get_fs();
            set_fs(KERNEL_DS);
      
            file = filp_open(SCA, O_WRONLY|O_CREAT, 0644);
             
	    memset((char *)buf, 0, 64); 
            for (i = 0; i < MAX_SYSCALL; i++)
            {  
         	    	sprintf(buf, "%p\n", (void *)sys_call_table[i]);
          		file->f_op->write(file, (char *)buf, 9, &file->f_pos);
          		memset((char *)buf, 0, 64);      
    	    }

 
 	  filp_close(file, NULL);
 	  set_fs(o_fs);
	  kfree(buf);

 return 0;
} 

int sct_end(void)
{
   return 0;
} 



module_init(sct_query);
module_exit(sct_end);
