#!/bin/bash

# run from trunk/ directory to build symlinks from /var/kmt/ to svn local copy


set -x 
KMT_PREFIX=/opt/kmt
KMT_SBIN=${KMT_PREFIX}/sbin
KMT_CERTS=${KMT_PREFIX}/certs
TOOLS="kmond kmtd dps dr_chk kmemstat ksymstat ktraq"


mkdir -p ${KMT_SBIN}
mkdir -p ${KMT_CERTS}

for TOOL in ${TOOLS}
do
	rm -f ${KMT_SBIN}/${TOOL}
	ln -s ${PWD}/${TOOL}/${TOOL} ${KMT_SBIN}/${TOOL}
done

#additional stuff
rm -f ${KMT_SBIN}/syscall.tab
ln -s ${PWD}/ktraq/syscall.tab ${KMT_SBIN}/syscall.tab

#ktraq_module dir symlink
rm -f ${KMT_SBIN}/ktraq_module
ln -s ${PWD}/ktraq/ktraq_module ${KMT_SBIN}/ktraq_module

rm -f ${KMT_PREFIX}/kmt.conf
ln -s ${PWD}/kmtd/kmt.conf ${KMT_PREFIX}/kmt.conf

rm -f ${KMT_CERTS}/cert.pem
ln -s ${PWD}/kmtd/certs/server/cert.pem ${KMT_CERTS}/cert.pem

rm -f ${KMT_CERTS}/privkey.pem
ln -s ${PWD}/kmtd/certs/server/privkey.pem ${KMT_CERTS}/privkey.pem
